#include <gtk/gtk.h>
#include <stdlib.h> 
#include <stdio.h> 
#include <string.h>
#include <unistd.h>
#include "gui/interface.h"
#include "gui/support.h"
#include "gui/callbacks.h"
#include "tvutils.h"
GtkWidget               *window;
  
  

 
char * versionName(char*cadena)
{
	char * nombre=malloc(250);
	strcpy(nombre,"Debian ");
	switch (cadena[0])
	{
	case '2':
		switch (cadena[2])
		{
			case '2':		
			strcat(nombre,"Potato");
			break;
		}
	case '3':
		switch (cadena[2])
		{
			case '0':		
				strcat(nombre,"Woody");
				break;
			case '1':
				strcat(nombre,"Sarge");
				break;
		}
	case '4':
		strcat(nombre,"Etch");
		break;
	case '5' :
		strcat(nombre,"Lenny");
		break;
	case '6' :
		strcat(nombre,"Squeeze");
		break;

	}
	return nombre;

	
}
char* getVersionInfo(char* cadena)
{
	char*temp;
	char * salida= malloc(100);		
	temp=versionName(cadena );	
	strcpy(salida,temp);
	free(temp);

	strcat(salida, " ");
	strcat(salida, cadena);	

	return salida;
	
}
FILE* openDebianVersionFile()
{
	FILE *f;
	if (!(f=fopen("/etc/debian_version","r")))
	{	
		GtkWidget * errorMessage =  gtk_message_dialog_new (GTK_WINDOW(window), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK,"Error");
		if (access("/etc/debian_version",R_OK))
		{
			if (access("/etc/debian_version",F_OK)==-1)
			{
				gtk_message_dialog_format_secondary_text((GtkMessageDialog *)errorMessage,"Es probable que no se trate de una distribución basada en Debian");			
			}
			else
			{
				gtk_message_dialog_format_secondary_text((GtkMessageDialog *)errorMessage,"No tiene permisos para conocer la versión de la distribución");
			}	
		}				
		gtk_dialog_run((GtkDialog*)errorMessage); 	        
		gtk_widget_destroy ((GtkWidget*)errorMessage);        		
		return 0;
	}
	else
	{
		return f;
	}
}

FILE* openLihuenVersionFile()
{
	FILE *f;
	if (!(f=fopen("/etc/lihuen_version","r")))
	{	
		GtkWidget * errorMessage =  gtk_message_dialog_new (GTK_WINDOW(window), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK,"Error");
		if (access("/etc/lihuen_version",R_OK))
		{
			if (access("/etc/lihuen_version",F_OK)==-1)
			{
				gtk_message_dialog_format_secondary_text((GtkMessageDialog *)errorMessage,"Es probable que no se trate de una distribución de Lihuen");			
			}
			else
			{
				gtk_message_dialog_format_secondary_text((GtkMessageDialog *)errorMessage,"No tiene permisos para conocer la versión de la distribución");
			}	
		}				
		gtk_dialog_run((GtkDialog*)errorMessage); 	        
		gtk_widget_destroy ((GtkWidget*)errorMessage);        		
		return 0;
	}
	else
	{
		return f;
	}
}
char* getVariedad(char* var)
{
    char * temp=malloc(20);
    if ((strcmp(var,"EST"))==0)
    {
        strcpy(temp,"Estandar");
    }
    else if( (strcmp(var,"KOHA")==0))
    {
        strcpy(temp,"Con KOHA");
    }
    else 
    {
       strcpy(temp,var);   
    }
    return temp;
}
char* setLihuenVersion(int etapa, char* info)
{
  GtkWidget* widget;
  char *temp;
  switch (etapa)
  {
    case 1:
      widget= lookup_widget     (window, "enrtyLihuenState");
      gtk_entry_set_text (GTK_ENTRY(widget),info);
      break; 
    case 0:
     temp=malloc(50);
      sprintf(temp,"%s %s", "Lihuen" , info);
      widget= lookup_widget     (window, "entryLihuenVersion");
      gtk_entry_set_text (GTK_ENTRY(widget),temp);
      free(temp);

      break;
      
   default:
   	return info;
	break;
      
  }
  return info;
  		
  
}
int main (int argc, char *argv[])
{
     
      
	GtkEntry  	*entryVersion;
	GtkImage *image;
	gchar* temp;
	FILE* f;	
	gchar* cadena;

       gtk_set_locale ();
       gtk_init (&argc, &argv);

	 window = create_debianVersion ();
	


		if((f=openDebianVersionFile()))
		{		
			cadena= malloc(100);
			fscanf(f, "%s",cadena);
			temp=getVersionInfo(cadena);
			free(cadena);
			fclose(f);
			
			
			image= GTK_IMAGE(lookup_widget     (window, "image1"));
			gtk_image_set_from_file(image, DATADIR"/icons/debianVersion.png");              
			

			entryVersion=GTK_ENTRY( lookup_widget     (window, "entryVersion"));
			gtk_entry_set_text (entryVersion,temp);
		
 
			
			free(temp);        
		}
		if((f=openLihuenVersionFile())) {
		    char * pch;
		    int etapa=0;
			cadena= malloc(100);
			fgets(cadena,99,f);
			cadena[strlen(cadena)-1]=0;
			pch=strtok(cadena," ");
			etapa=0;
			while (pch != NULL) {							  
              setLihuenVersion(etapa,pch);
			  etapa++;
			  pch = strtok (NULL, " ");
			}
			fclose(f);
			if ((fopen("/etc/lihuen_live","r"))) { 
		        	gtk_widget_show(lookup_widget (window, "labelLiveCd"));
			}
			/**
			*   Tomo los datos de taskel 
			*/
			GtkWidget* w=GTK_WIDGET(lookup_widget(window,"Variedades")); 
			
			initializeTreeView(w,0,(char*[][2]){   {"Tareas" , "text" } });
			FILE* fpackages= popen(" tasksel --list-tasks | grep ^i  | cut -f2-","r");
			char* package= malloc(251);
			while  (fgets(package, 250, fpackages) != NULL) {
			    char *nlptr = strchr(package, '\n');
                 if (nlptr) *nlptr = '\0';
			    append_item(w,package);
			        
			}   
			pclose(fpackages);
			gtk_tree_view_set_rules_hint(w,1);
			image=GTK_IMAGE( lookup_widget     (window, "image2"));
			gtk_image_set_from_file(image, DATADIR"/icons/lihuenVersion.png");              
			
		}

		        gtk_widget_show (window);       
    	    gtk_main ();
			return 0;

	return 1;        
     
}

