
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include "tvutils.h"

 void append_item_to_model(GtkListStore *store, char* str)
{

  GtkTreeIter  iter;
  gtk_list_store_append(store, &iter);
  gtk_list_store_set(store, &iter, 0, str, -1);
}
 void append_item(GtkTreeView *widget, char* str)
{
  GtkListStore *store;
  GtkTreeIter  iter;
  store =GTK_LIST_STORE( gtk_tree_view_get_model(GTK_TREE_VIEW(widget)));
  gtk_list_store_append(store, &iter);
  gtk_list_store_set(store, &iter, 0, str, -1);
}

 void remove_item(GtkTreeView *widget, char* str)
{
  GtkListStore *store;
  GtkTreeIter  iter;
  store =GTK_LIST_STORE( gtk_tree_view_get_model(GTK_TREE_VIEW(widget)));
  gtk_list_store_remove(store, &iter);
  gtk_list_store_set(store, &iter, 0, str, -1);
}

void clear_treeview(GtkTreeView *widget)
{
  GtkListStore *store;  
  store =GTK_LIST_STORE( gtk_tree_view_get_model(GTK_TREE_VIEW(widget)));  
  gtk_list_store_clear(store);
  
}
int userIsInList(char** userList, char* user)
{
        while (*userList)
        {
                if (strcmp(*userList, user)==0)
                {
                        return 1;
                }
                userList++;
        }
        return 0;
}


char* append(char* a, char *b, int cr)
{
  char* temp;
  int size=strlen(a)+(strlen(b)+10);
  if (cr)
    size+=2;    
  temp=malloc(size);
  strcpy(temp,a);
  strcat(temp,b);

  if (cr)
  {
    temp[size-2]='\n';
    temp[size-1]=0;
  }
  return temp;
  
}

int executeCommandAppendError(const char* p_command, GSList ** errorList)
{
		
	char* command= malloc(strlen(p_command)+29);
	sprintf(command, "%s  2>&1 1>/dev/null", p_command);
	
	 FILE* po=popen(command,"r");
	
	 char* errorDescription=calloc(sizeof(char),250);
	  char* errorDes=calloc(sizeof(char),250);
	  
	  while  (fgets(errorDes, 250, po) != NULL){	  }   
	  
	  
	  if (strlen(errorDes)!=0)
	  {
		 
		  strcpy(errorDescription,errorDes);	
		  *errorList=g_slist_append(*errorList, (gpointer) errorDescription);
		  return 0;
	  }
	  else
	  {
		free(errorDescription);
	  }
	    
	  free(errorDes);	  
	  pclose(po);     	  
	  free(command);
	  return 1;	 
 
}


void initializeTreeView(GtkTreeView* list, int multiple, char * datos[][2])
{
      GtkCellRenderer    *renderer;
  GtkTreeViewColumn  *column;
  GtkListStore *groups;

    GtkTreeSelection* selection;
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
    if (multiple) { 
        gtk_tree_selection_set_mode(selection, GTK_SELECTION_SINGLE); 
    } else {
       gtk_tree_selection_set_mode(selection, GTK_SELECTION_MULTIPLE);
    }      
    renderer = gtk_cell_renderer_text_new();
    column = gtk_tree_view_column_new_with_attributes(datos[0][0],renderer, datos[0][1], 0, NULL);
    if (strcmp(datos[0][1],"text")==0) {
        gtk_tree_view_append_column(GTK_TREE_VIEW (list), column);
        groups=gtk_list_store_new(1,G_TYPE_STRING);
     }
     gtk_tree_view_set_rules_hint(list,1);
     gtk_tree_view_set_model(GTK_TREE_VIEW(list),GTK_TREE_MODEL(groups));
}
